#!/bin/sh
#############################################
#  Autor: 		Stefan.Freisler@aspect-online.de
# Homepage:	http://dev.c6c.de
#  Licence: 		GPLv2
#  Version: 		0.3.0  -  07.02.2007
#  Desc: 		With this Script you can view Graphs with exact values
#############################################
#Print HTML-Header you can't print Output before
echo "content-type: text/html"
echo ""

#############################################
# Configuration 
# Many Things will autmatically loaded
# Normaly you must only touch this section
#############################################
COLOR="blue"
THIS_TITLE="View Graphs"

# Change to point to your hobbit server config file
HOBBIT_SERVER_CFG="../server/etc/hobbitserver.cfg"
ADMINSCRIPS_FUNCTIONS="../server/etc/adminscripts_functions.sh"

this_usePerl="false" #if you have perl (Use it when you have Problems with date (e.g. on Solaris))

#############################################
#Init Script
#############################################
#Load Hobbit configuration
. $HOBBIT_SERVER_CFG
. $ADMINSCRIPS_FUNCTIONS
this_timestamp;this_create_time_start="$RETURN"

#Get Hobbit Version:
HOBBIT_VERSION=`$BB --version 2>&1 |$GREP "Hobbit version"|$AWK '{printf "%s",$3}'`

#init Vars
query=""

#Init Environment
THIS_FILENAME=`basename $0`

this_getHosts;HOSTS="$RETURN"

GRAPH1=`echo "$GRAPHS" | $SED "s/,/ /g"`

#Use Requestparameters from GET or Post
if [ "$REQUEST_METHOD" = POST ]; then
	read -n $CONTENT_LENGTH query
else
    query="$QUERY_STRING"
fi

#Check Query
this_cgiascii "$query"
this_getQuery "$query" "host";HOST_S="$RETURN"
this_getQuery "$query" "graph";GRAPH_S="$RETURN"
this_getQuery "$query" "time1";TIME1_S="$RETURN"
this_getQuery "$query" "time2";TIME2_S="$RETURN"
this_getQuery "$query" "rrdheight";RRDHEIGHT_S="$RETURN"
this_getQuery "$query" "rrdwidth";RRDWIDTH_S="$RETURN"
this_getQuery "$query" "number";COUNT_S="$RETURN"
this_getQuery "$query" "first";FIRST_S="$RETURN"

if [ "$COUNT_S" = "" ]; then
    COUNT_S=1
fi

if [ "$FIRST_S" = "" ]; then
    FIRST_S=1
fi

#Set default Time in Boxes
if [ "$TIME1_S" = "" ]; then
	this_timestamp;timestamp="$RETURN"
	timestamp=$(($timestamp - 86400 ))
	this_PrintDate "$timestamp";TIME1_S="$RETURN"
fi

if [ "$TIME2_S" = "" ]; then
	this_timestamp;timestamp="$RETURN"
	this_PrintDate "$timestamp";TIME2_S="$RETURN"
fi

THIS_SCRIPT_HEADER="
<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"$BBWEBHOSTURL/calendar/skins/aqua/theme.css\" />
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/calendar_stripped.js\"></script>
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/lang/calendar-en.js\"></script>
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/calendar-setup_stripped.js\"></script>
"

#############################################
#Print HTML Page and do
#############################################
# Load Header
. "$BBHOME/web/adminscripts_header"

#Select Log
echo "<table><form action=\"./$THIS_FILENAME\" method=\"post\">
	<tr>
		<td>Host:</td>
		<td> <select name=\"host\">"
for HOST in $HOSTS
do
	echo "<option value=\"$HOST\""
	if [ "$HOST_S" = "$HOST" ]; then echo " selected ";	fi
	echo ">$HOST</option>"
done
echo "</select></td>
	<td></td>
	<td></td></tr>
	<tr><td>Service: </td>
	<td><select name=\"graph\">"
	
IFSBAK=$IFS
IFS=" "
for GRAPH in $GRAPH1
do
	GRAPH=`echo $GRAPH|sed "s/::1//g"`
	echo "<option value=\"$GRAPH\""
	if [ "$GRAPH_S" = "$GRAPH" ]; then echo " selected "; fi
	echo ">$GRAPH</option>"
done
IFS=$IFSBAK

echo "</select></td>
	<td></td>
	<td></td>
	</tr>"

#Time1
echo '<tr>
		<td>From: </td>
		<td><input type="text" name="time1" id="f_date_a" value="'$TIME1_S'"/>
<img src="'"$BBWEBHOSTURL"'/calendar/img.gif" id="f_trigger_a" style="border: 1px solid red; cursor: pointer;" title="Date selector" onmouseover="this.style.background='"'red'"';" onmouseout="this.style.background='"''"'">
<script type="text/javascript">
    Calendar.setup({
        inputField     :    "f_date_a",      // id of the input field
        ifFormat       :    "%Y/%m/%d %H:%M",       // format of the input field
        showsTime      :    true,            // will display a time selector
        button         :    "f_trigger_a",   // trigger for the calendar (button ID)
        singleClick    :    false,           // double-click mode
        step           :    1                // show all years in drop-down boxes (instead of every other year as default)
    });
</script>'

#Time2
echo '</td>
	<td>To: </td>
	<td><input type="text" name="time2" id="f_date_b" value="'$TIME2_S'"/>
<img src="'"$BBWEBHOSTURL"'/calendar/img.gif" id="f_trigger_b" style="border: 1px solid red; cursor: pointer;" title="Date selector" onmouseover="this.style.background='"'red'"';" onmouseout="this.style.background='"''"'">
<script type="text/javascript">
    Calendar.setup({
        inputField     :    "f_date_b",      // id of the input field
        ifFormat       :    "%Y/%m/%d %H:%M",       // format of the input field
        showsTime      :    true,            // will display a time selector
        button         :    "f_trigger_b",   // trigger for the calendar (button ID)
        singleClick    :    false,           // double-click mode
        step           :    1                // show all years in drop-down boxes (instead of every other year as default)
    });
</script></td></tr>'

if [ "$RRDWIDTH_S" = "" ]; then RRDWIDTH_S=$RRDWIDTH; fi
if [ "$RRDHEIGHT_S" = "" ]; then RRDHEIGHT_S=$RRDHEIGHT; fi
echo "<tr>
		<td>Width:</td>
		<td> <input type=\"text\" name=\"rrdwidth\" value=\"$RRDWIDTH_S\"></td>
		<td>Height:</td>
		<td> <input type=\"text\" name=\"rrdheight\" value=\"$RRDHEIGHT_S\"></td>
	</tr>"
echo "<tr>
		<td>Number:</td>
		<td> <input type=\"text\" name=\"number\" value=\"$COUNT_S\"></td>
		<td></td>
		<td></td>
		<td></td>
	</tr>"
echo "<tr>
		<td></td>
		<td><input type=\"submit\" value=\"Submit\"></td>
		<td></td>
		<td></td>
	</tr></form>"

echo "</table><hr>"

#Command
this_getDate "$TIME1_S";FROM_S="$RETURN"
this_getDate "$TIME2_S";TO_S="$RETURN"

#Test if more than one Available
FIRST=(`$LS $BBRRDS/$HOST_S/$GRAPH_S*.rrd`)
len=$(( ${#FIRST[*]} + 1))
i=$FIRST_S
echo "<table>"
while [ $i -lt $len ]; do
	echo "<tr>
			<td>
				<a href=\"$BBSERVERCGIURL/hobbitgraph.sh?host=$HOST_S&service=$GRAPH_S&graph_height=$RRDHEIGHT_S&graph_width=$RRDWIDTH_S&first=$i&count=$COUNT_S&action=menu\">
					<img src=\"$BBSERVERCGIURL/hobbitgraph.sh?host=$HOST_S&service=$GRAPH_S&graph_height=$RRDHEIGHT_S&graph_width=$RRDWIDTH_S&graph_start=$FROM_S&graph_end=$TO_S&first=$i&count=$COUNT_S\" alt=\"Graph Error or not available\">
				</a>
			</td>
			<td>
				<a href=\"$BBSERVERCGIURL/hobbitgraph.sh?host=$HOST_S&service=$GRAPH_S&graph_height=$RRDHEIGHT_S&graph_width=$RRDWIDTH_S&first=$i&count=$COUNT_S&action=selzoom&graph_start=$FROM_S&graph_end=$TO_S\"> 
					<img src=\"$BBWEBHOSTURL/gifs/zoom.gif\" alt=\"Zoom graph\" style=\"padding: 3px;\" border=\"0\"> 
				</a>
			</td>
		</tr>"
	let i=$i+$COUNT_S
done
echo "</table>"

if [ "$len" -le 1 ]; then 
	echo "No graph available" 
fi


# Load Footer
this_timestamp;this_create_time_end="$RETURN"
this_create_time=$(($this_create_time_end - $this_create_time_start)) 
. "$BBHOME/web/adminscripts_footer"

exit 0;
