#!/bin/sh
#############################################
#  Autor: 		Stefan.Freisler@aspect-online.de
# Homepage:	http://dev.c6c.de
#  Licence: 		GPLv2
#  Version: 		0.3.0  -  07.02.2007
#  Desc: 		With this Script you can view when was send a notification
#############################################
#Print HTML-Header you can't print Output before
echo "content-type: text/html"
echo ""

#############################################
# Configuration 
# Many Things will autmatically loaded
# Normaly you must only touch this section
#############################################
COLOR="blue"
THIS_TITLE="View Notifications"

# Change to point to your hobbit server config file
HOBBIT_SERVER_CFG="../server/etc/hobbitserver.cfg"
ADMINSCRIPS_FUNCTIONS="../server/etc/adminscripts_functions.sh"

this_usePerl="false" #if you have perl (Use it when you have Problems with date (e.g. on Solaris))

LOGPATH=$BBSERVERLOGS  #if you add here Something Logspath will not set automatically
LOGFILE="notifications.log" # Name of notifications.log

#############################################
#Init Script
#############################################
#Load Hobbit configuration
. $HOBBIT_SERVER_CFG
. $ADMINSCRIPS_FUNCTIONS
this_timestamp;this_create_time_start="$RETURN"

#Get Hobbit Version:
HOBBIT_VERSION=`$BB --version 2>&1 |$GREP "Hobbit version"|$AWK '{printf "%s",$3}'`

#init Vars
query=""
HOST_S=""
TEST_S=""
REC_S=""
if [ "$LOGPATH" = "" ]; then
	LOGPATH=$BBSERVERLOGS
fi

#Init Environment
THIS_FILENAME=`basename $0`

this_getHosts;HOSTS="$RETURN"

GRAPH1=`echo "$GRAPHS" | $SED "s/,/ /g"`

#Use Requestparameters from GET or Post
if [ "$REQUEST_METHOD" = POST ]; then
	read -n $CONTENT_LENGTH query
else
    query="$QUERY_STRING"
fi

#Check Query
this_cgiascii "$query"
this_getQuery "$query" "host";HOST_S="$RETURN"
this_getQuery "$query" "test";TEST_S="$RETURN"
this_getQuery "$query" "time1";TIME1_S="$RETURN"
this_getQuery "$query" "time2";TIME2_S="$RETURN"
this_getQuery "$query" "rec";REC_S="$RETURN"

#Set default Time in Boxes
if [ "$TIME1_S" = "" ]; then
	this_timestamp;timestamp="$RETURN"
	timestamp=$(($timestamp - 86400 ))
	this_PrintDate "$timestamp";TIME1_S="$RETURN"
fi

if [ "$TIME2_S" = "" ]; then
	this_timestamp;timestamp="$RETURN"
	this_PrintDate "$timestamp";TIME2_S="$RETURN"
fi

THIS_SCRIPT_HEADER="
<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"$BBWEBHOSTURL/calendar/skins/aqua/theme.css\" />
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/calendar_stripped.js\"></script>
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/lang/calendar-en.js\"></script>
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/calendar-setup_stripped.js\"></script>
"

#############################################
#Print HTML Page and do
#############################################
# Load Header
. "$BBHOME/web/adminscripts_header"

echo "<form action=\"./$THIS_FILENAME\" method=\"post\">"
echo "<table>"
#Time1
echo '<tr><td>From: </td><td><input type="text" name="time1" id="f_date_a" value="'$TIME1_S'"/>
<img src="'"$BBWEBHOSTURL"'/calendar/img.gif" id="f_trigger_a" style="border: 1px solid red; cursor: pointer;" title="Date selector" onmouseover="this.style.background='"'red'"';" onmouseout="this.style.background='"''"'">
<script type="text/javascript">
    Calendar.setup({
        inputField     :    "f_date_a",      // id of the input field
        ifFormat       :    "%Y/%m/%d %H:%M",       // format of the input field
        showsTime      :    true,            // will display a time selector
        button         :    "f_trigger_a",   // trigger for the calendar (button ID)
        singleClick    :    false,           // double-click mode
        step           :    1                // show all years in drop-down boxes (instead of every other year as default)
    });
</script></td></tr>'

#Time2
echo '<tr><td>To: </td><td><input type="text" name="time2" id="f_date_b" value="'$TIME2_S'"/>
<img src="'"$BBWEBHOSTURL"'/calendar/img.gif" id="f_trigger_b" style="border: 1px solid red; cursor: pointer;" title="Date selector" onmouseover="this.style.background='"'red'"';" onmouseout="this.style.background='"''"'">
<script type="text/javascript">
    Calendar.setup({
        inputField     :    "f_date_b",      // id of the input field
        ifFormat       :    "%Y/%m/%d %H:%M",       // format of the input field
        showsTime      :    true,            // will display a time selector
        button         :    "f_trigger_b",   // trigger for the calendar (button ID)
        singleClick    :    false,           // double-click mode
        step           :    1                // show all years in drop-down boxes (instead of every other year as default)
    });
</script></td></tr>'

echo "<tr><td>Recipient</td><td><input type=\"text\" name=\"rec\"  value=\"$REC_S\"/></td></tr>";
echo "<tr><td>Sever</td><td><input type=\"text\" name=\"host\"  value=\"$HOST_S\"/></td></tr>";
echo "<tr><td>Test</td><td><input type=\"text\" name=\"test\"  value=\"$TEST_S\"/></td></tr>";
echo "<tr><td></td><td><input type=\"submit\" value=\"Submit\"></td></tr>"
echo "</table>"
echo "</form>"



echo "<table summary=Notifications border=1>"
echo "<tr><th align=left>Time</th><th align=left>Host.service</th><th align=left>Recipient</th></tr>"

#Create Timestamps to compare it.
this_getDate "$TIME1_S";FROM_S="$RETURN"
this_getDate "$TIME2_S";TO_S="$RETURN"
while read LINE; do
	nTIME=`echo "$LINE"| awk '{printf "%s",$9}'`
	nHOST_ALL=`echo "$LINE"| awk '{printf "%s",$6}'`
	nREC=`echo "$LINE"| awk '{printf "%s",$8}'`
	if [ $nTIME -ge $FROM_S -a $nTIME -lt $TO_S ]; then
		nREC_count=`echo "$nREC"| grep -e "$REC_S"|wc -l`
		if [ "$REC_S" = "" -o "$nREC_count" = 1 ]; then
			nHOST_HOST=`echo "$nHOST_ALL"| grep -e "$HOST_S.*"|wc -l`
			if [ "$HOST_S" = "" -o "$nHOST_HOST" = "1" ]; then
				nHOST_TEST=`echo "$nHOST_ALL"| grep -e "$TEST_S.*"|wc -l`
				if [ "$TEST_S" = "" -o "$nHOST_TEST" = "1" ]; then
					this_PrintDate "$nTIME";nTIME="$RETURN"
					echo "<tr><td>" $nTIME "</td><td>$nHOST_ALL</td><td>$nREC</td></tr>"
				fi
			fi
		fi
	fi
done < "$LOGPATH/$LOGFILE"
 
 
echo "</table>"

# Load Footer
this_timestamp;this_create_time_end="$RETURN"
this_create_time=$(($this_create_time_end - $this_create_time_start)) 
. "$BBHOME/web/adminscripts_footer"

exit 0;
