#!/bin/sh
#############################################
#  Autor: 		Stefan.Freisler@aspect-online.de
# Homepage:	http://dev.c6c.de
#  Licence: 		GPLv2
#  Version: 		0.3.0  -  07.02.2007
#  Desc: 		With this Script you can delete Services or complete Host with History
#             		or you can rename them
#############################################
#Print HTML-Header you can't print Output before
echo "content-type: text/html"
echo ""

#############################################
# Configuration 
# Many Things will autmatically loaded
# Normaly you must only touch this section
#############################################
COLOR="blue"
THIS_TITLE="Rename Hosts / Delete Hosts or Services"

# Change to point to your hobbit server config file
HOBBIT_SERVER_CFG="../server/etc/hobbitserver.cfg"
ADMINSCRIPS_FUNCTIONS="../server/etc/adminscripts_functions.sh"
LOGS="" #if you add here Something Logspath will not set automatically

this_usePerl="false" #if you have perl (Use it when you have Problems with date (e.g. on Solaris))

FAST_SERVICES="false" #Less comfort because it will not use JavaScript 

#############################################
#Init Script
#############################################
#Load Hobbit configuration
. $HOBBIT_SERVER_CFG
. $ADMINSCRIPS_FUNCTIONS
this_timestamp;this_create_time_start="$RETURN"

#Get Hobbit Version:
HOBBIT_VERSION=`$BB --version 2>&1 |$GREP "Hobbit version"|$AWK '{printf "%s",$3}'`


#init Vars
SEL=""
SERVICES=""
ACTION=""
query=""
if [ "$LOGS" = "" ]; then
	LOGS=$BBSERVERLOGS
fi

#Init Environment
THIS_FILENAME=`basename $0`

#Use Requestparameters from GET or Post
if [ "$REQUEST_METHOD" = POST ]; then
	read -n $CONTENT_LENGTH query
else
    query="$QUERY_STRING"
fi

#Create additional Script Header

#get all Hosts Ordered and no doubles
if [ "$FAST_SERVICES" = "true" ]; then
	this_getHosts;HOSTS="$RETURN"
	this_getServices;SERVICES="$RETURN"
else
	this_getHeaderHobbitdboard;THIS_SCRIPT_HEADER="$THIS_SCRIPT_HEADER$RETURN"
fi

#Check Query
this_cgiascii "$query" 
this_getQuery "$query" "hostname";HOST_S="$RETURN"
this_getQuery "$query" "new";NEW_S="$RETURN"
this_getQuery "$query" "servicename";SERVICE_S="$RETURN"
this_getQuery "$query" "action";ACTION="$RETURN"
this_getQuery "$query" "sel";SEL="$RETURN"

#############################################
#Print HTML Page and do
#############################################
# Load Header
. "$BBHOME/web/adminscripts_header"

if [ "$SERVICE_S" = "ALL" ]; then
	SERVICE_S=""
fi

if [ "$ACTION" = "ASK" ]; then
	if [ "$SEL" = "del" ]; then
	    echo "Are you shure you wan't del $HOST_S $SERVICE_S?"
		echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
		<input type=\"hidden\" name=\"hostname\" value=\"$HOST_S\" />
		<input type=\"hidden\" name=\"servicename\" value=\"$SERVICE_S\" />
		<input type=\"hidden\" name=\"sel\" value=\"del\" />
		<input type=\"hidden\" name=\"action\" value=\"DO\" />
		<input type=\"submit\" value=\"Submit\" /></form><br />"
	elif [ "$SEL" = "edit" ]; then
	    echo "Are you shure you wan't rename $HOST_S $NEW_S?"
		echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
		<input type=\"hidden\" name=\"hostname\" value=\"$HOST_S\" />
		<input type=\"hidden\" name=\"new\" value=\"$NEW_S\" />
		<input type=\"hidden\" name=\"sel\" value=\"edit\" />
		<input type=\"hidden\" name=\"action\" value=\"DO\" />
		<input type=\"submit\" value=\"Submit\" /></form><br />"
	fi
else
	if [ "$ACTION" = "DO" ]; then
		if [ "$SEL" = "del" ]; then
		    echo "$HOST_S $SERVICE_S successful deleted<br />"
			res=$($BB $BBSERVERIP "drop $HOST_S $SERVICE_S")
			echo "$BB $BBSERVERIP \"drop $HOST_S $SERVICE_S\""
			echo "<pre>$res</pre>"
			echo "`$DATE +\"%Y/%m/%d %H:%M:%S\"` - Deleted HOST $HOST_S SERVICES $SERVICE_S - Used Command: $BB $BBSERVERIP \"drop $HOST_S $SERVICE_S\" - $res" >> "$LOGS/adminscripts_chhostservice.log"
		elif [ "$SEL" = "edit" ]; then
		    echo "$HOST_S $SERVICE_S successful edited<br />"
			res=$($BB $BBSERVERIP "rename $HOST_S $NEW_S")
			echo "$BB $BBSERVERIP \"rename $HOST_S $NEW_S\""
			echo "<pre>$res</pre>"
			echo "`$DATE +\"%Y/%m/%d %H:%M:%S\"` - Changed Servername FROM $HOST_S TO $NEW_S - Used Command: $BB $BBSERVERIP \"rename $HOST_S $NEW_S\" - $res" >> "$LOGS/adminscripts_chhostservice.log"
		fi
	fi
	#Del
	echo "<h1>Delete</h1>"
	echo "<form action=\"./$THIS_FILENAME\" name=\"selectionform\" method=\"post\">"
	if [ "$FAST_SERVICES" = "true" ]; then
		echo '<select name="hostname" size="1">'
		for HOST in $HOSTS
		do
		    echo "<option value=\"$HOST\">$HOST</option>"
		done
		echo '</select>'
		echo '<select name="servicename" size="1">'
		echo "<option value=\"\">ALL</option>"
		for SERVICE in $SERVICES
		do
		    echo "<option value=\"$SERVICE\">$SERVICE</option>"
		done
		echo '</select><br /><br />'
	else
		echo '<select name="hostname" size="1" onChange="updateOptions(window.document.selectionform.hostname.options[selectedIndex].text);">'
		for HOST in $HOSTS
		do
		    echo "<option value=\"$HOST\">$HOST</option>"
		done
		echo '</select>'
		echo '<select name="servicename" size="1"><option value="">-- Select a host --</option></select><br /><br />'
	fi		
	echo "<input type=\"hidden\" name=\"sel\" value=\"del\">
	<input type=\"hidden\" name=\"action\" value=\"ASK\">
	<input type=\"submit\" value=\"Submit\"></form>"

	#Edit
	echo "<hr>"
	echo "<h1>Move</h1>"
	echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
	<select name=\"hostname\">"
	for HOST in $HOSTS
	do
		echo "<option value=\"$HOST\">$HOST</option>"
	done
	echo "</select><br /><br />
	<input type=\"text\" name=\"new\" value=\"NewHostName\"><br /><br />
	<input type=\"hidden\" name=\"sel\" value=\"edit\">
	<input type=\"hidden\" name=\"action\" value=\"ASK\">
	<input type=\"submit\" value=\"Submit\"></form>"
fi

echo "<hr>"


# Load Footer
this_timestamp;this_create_time_end="$RETURN"
this_create_time=$(($this_create_time_end - $this_create_time_start)) 
. "$BBHOME/web/adminscripts_footer"

exit 0;
