#!/bin/sh
#############################################
#  Autor: 		Stefan.Freisler@aspect-online.de
# Homepage:	http://dev.c6c.de
#  Licence: 		GPLv2
#  Version: 		0.3.0  -  07.02.2007
#  Desc: 		With this Script you can delete Services or complete Host with History
#             		or you can rename them
#############################################
#Print HTML-Header you can't print Output before
echo "content-type: text/html"
echo ""

#############################################
# Configuration 
# Many Things will autmatically loaded
# Normaly you must only touch this section
#############################################
COLOR="blue"
THIS_TITLE="Clean Hobbit"

# Change to point to your hobbit server config file
HOBBIT_SERVER_CFG="../server/etc/hobbitserver.cfg"
ADMINSCRIPS_FUNCTIONS="../server/etc/adminscripts_functions.sh"
LOGS="" #if you add here Something. Logspath will not set automatically
CLEANCMD="" #if you add here something. CLEANCMD will not set automatically

this_usePerl="false" #if you have perl (Use it when you have Problems with date (e.g. on Solaris))

FAST_SERVICES="false" #Less comfort because it will not use JavaScript 

#Select Files which should can downsized
FILEX=(/home/elvis/test/test.txt)

HEAD_CMD="head -n"
TAIL_CMD="tail -n"

#############################################
#Init Script
#############################################
#Load Hobbit configuration
. $HOBBIT_SERVER_CFG
. $ADMINSCRIPS_FUNCTIONS
this_timestamp;this_create_time_start="$RETURN"

#Get Hobbit Version:
HOBBIT_VERSION=`$BB --version 2>&1 |$GREP "Hobbit version"|$AWK '{printf "%s",$3}'`

#CMD's
if [ "$CLEANCMD" = "" ]; then
	CLEANCMD="$BBHOME/bin/trimhistory"
fi

#init Vars
SEL=""
SERVICES=""
ACTION=""
query=""

if [ "$LOGS" = "" ]; then
	LOGS=$BBSERVERLOGS
fi

#Init Environment
THIS_FILENAME=`basename $0`

#Use Requestparameters from GET or Post
if [ "$REQUEST_METHOD" = POST ]; then
	read -n $CONTENT_LENGTH query
else
    query="$QUERY_STRING"
fi

#Create additional Script Header

#Check Query
this_cgiascii "$query" 
this_getQuery "$query" "file";FILE_S="$RETURN"
this_getQuery "$query" "type";TYPE_S="$RETURN"
this_getQuery "$query" "lines";LINES_S="$RETURN"
this_getQuery "$query" "action";ACTION="$RETURN"
this_getQuery "$query" "sel";SEL="$RETURN"
this_getQuery "$query" "time1";TIME1_S="$RETURN"
this_getQuery "$query" "drop";DROP_S="$RETURN"

#Set default Time in Boxes
if [ "$TIME1_S" = "" ]; then
	this_timestamp;timestamp="$RETURN"
	this_PrintDate "$timestamp";TIME1_S="$RETURN"
fi

if [ "$TYPE_S" = "$HEAD_CMD" ]; then
	TYPE_S="$HEAD_CMD"
elif [ "$TYPE_S" = "$TAIL_CMD" ]; then
	TYPE_S="$TAIL_CMD"
else
	TYPE_S=""
fi

THIS_SCRIPT_HEADER="
<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"$BBWEBHOSTURL/calendar/skins/aqua/theme.css\" />
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/calendar_stripped.js\"></script>
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/lang/calendar-en.js\"></script>
<script type=\"text/javascript\" src=\"$BBWEBHOSTURL/calendar/calendar-setup_stripped.js\"></script>
"

#############################################
#Print HTML Page and do
#############################################
# Load Header
. "$BBHOME/web/adminscripts_header"

if [ "$ACTION" = "ASK" ]; then

	if [ "$SEL" = "clean" ]; then
		DROPCMD=""
		if [ "$DROP_S" = "yes" ]; then
			echo "Are you shure you wan't clean (Delete all data from Hosts, which are not in bbhost)?"
		else
			echo "Are you shure you wan't clean all date older than $TIME1_S?"
		fi
		echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
		<input type=\"hidden\" name=\"time1\" value=\"$TIME1_S\" />
		<input type=\"hidden\" name=\"drop\" value=\"$DROP_S\" />
		<input type=\"hidden\" name=\"sel\" value=\"clean\" />
		<input type=\"hidden\" name=\"action\" value=\"DO\" />
		<input type=\"submit\" value=\"Submit\" /></form><br />"
	elif [ "$SEL" = "cut" -a  "$TYPE_S" = "$HEAD_CMD" -o  "$TYPE_S" = "$TAIL_CMD" ]; then
	    echo "Are you shure you wan't cut $FILE_S and rescue $LINES_S lines $TYPE_S?"
		echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
		<input type=\"hidden\" name=\"file\" value=\"$FILE_S\" />
		<input type=\"hidden\" name=\"type\" value=\"$TYPE_S\" />
		<input type=\"hidden\" name=\"lines\" value=\"$LINES_S\" />
		<input type=\"hidden\" name=\"sel\" value=\"cut\" />
		<input type=\"hidden\" name=\"action\" value=\"DO\" />
		<input type=\"submit\" value=\"Submit\" /></form><br />"
	fi
else
	if [ "$ACTION" = "DO" ]; then
		if [ "$SEL" = "clean" ]; then
			DROPCMD=""
			this_getDate "$TIME1_S";CUTOFF_S="$RETURN"
			if [ "$DROP_S" = "yes" ]; then
				DROPCMD="--drop"
			fi
			res=$($CLEANCMD  $DROPCMD --cutoff=$CUTOFF_S 2>&1)  
			echo "Successful cleaned<br />"
			echo "$CLEANCMD $DROPCMD --cutoff=$CUTOFF_S"
			echo "<pre>$res</pre>"
			echo "`$DATE +\"%Y/%m/%d %H:%M:%S\"` - Cleaned Server - Used Command: $CLEANCMD $DROPCMD --cutoff=$TIME1_S - $res" >> "$LOGS/adminscripts_clean.log"
		elif [ "$SEL" = "cut" -a  "$TYPE_S" = "$HEAD_CMD" -o  "$TYPE_S" = "$TAIL_CMD"  ]; then
			if [ ! -e "$FILE_S" ]; then
				echo "$FILE_S (not exist)"
			elif [ ! -w "$FILE_S" ]; then
				echo "$FILE_S (not writeable)"
			else
				tempfile=`$CAT $FILE_S|$TYPE_S $LINES_S`
				res=$(echo "$tempfile" > $FILE_S)  
				echo "$CAT $FILE_S|$TYPE_S $LINES_S"
				echo "$FILE_S successful cut<br />"
				echo "echo \"$tempfile\" > $FILE_S"
				echo "<pre>$res</pre>"
				echo "`$DATE +\"%Y/%m/%d %H:%M:%S\"` - Cut Logfiles - Used Command: echo \"$tempfile\" > $FILE_S" >> "$LOGS/adminscripts_clean.log"
			fi
		fi
	fi
	
	#Clean
	echo "<hr>"
	#Clean Trim History
	echo "<form action=\"./$THIS_FILENAME\" method=\"post\">"
	echo "<h1>Clean not used Hosts</h1>"
	echo '
		<table><tr><td>From</td><td>
		<input type="text" name="time1" id="f_date_a" value="'$TIME1_S'"/>
		<img src="'"$BBWEBHOSTURL"'/calendar/img.gif" id="f_trigger_a" style="border: 1px solid red; cursor: pointer;" title="Date selector" onmouseover="this.style.background='"'red'"';" onmouseout="this.style.background='"''"'">
		<script type="text/javascript">
	    Calendar.setup({
	        inputField     :    "f_date_a",      // id of the input field
	        ifFormat       :    "%Y/%m/%d %H:%M",       // format of the input field
	        showsTime      :    true,            // will display a time selector
	        button         :    "f_trigger_a",   // trigger for the calendar (button ID)
	        singleClick    :    false,           // double-click mode
	        step           :    1                // show all years in drop-down boxes (instead of every other year as default)
	    });
	</script></td></tr>'
	echo "<tr><td></td><td><input type=\"hidden\" name=\"sel\" value=\"clean\">
		<input type=\"checkbox\" name=\"drop\" value=\"yes\"> Drop Test which not in bbhosts<br>
		<input type=\"hidden\" name=\"action\" value=\"ASK\">
		<input type=\"submit\" value=\"Clean\"></td></tr></table></form>"
	
	#Cut Big Files
	
	echo "<hr>"
	echo "<form action=\"./$THIS_FILENAME\" method=\"post\">"
	echo "<h1>Cut Files</h1>"
	echo "<table><tr><td>File </td><td><select name=\"file\">"
	len=${#FILEX[*]}
	i=0
	while [ $i -lt $len ]; do
		if [ "$FILE_S" = "${FILEX[$i]}" ]; then
			echo "<option value=\"${FILEX[$i]}\" selected>${FILEX[$i]}</option>"
		else	
			echo "<option value=\"${FILEX[$i]}\">${FILEX[$i]}</option>"
		fi
		let i++
	done
	echo "</select></td></tr>"
	echo "<tr><td>Rescue</td><td><select name=\"type\">"
	echo "<option value=\"$TAIL_CMD\">$TAIL_CMD</option>"
	echo "<option value=\"$HEAD_CMD\">$HEAD_CMD</option>"
	echo "</select></td></tr>"
	echo "<tr><td>Rescue Lines</td><td><input type=\"text\" name=\"lines\" value=\"1024\"/></td></tr>"
	echo "<tr><td></td><td><input type=\"hidden\" name=\"sel\" value=\"cut\">
		<input type=\"hidden\" name=\"action\" value=\"ASK\">
		<input type=\"submit\" value=\"Cut\"></td></tr></form>"
fi

echo "<hr>"


# Load Footer
this_timestamp;this_create_time_end="$RETURN"
this_create_time=$(($this_create_time_end - $this_create_time_start)) 
. "$BBHOME/web/adminscripts_footer"

exit 0;
