#!/bin/sh
#############################################
#  Autor: 		Stefan.Freisler@aspect-online.de
# Homepage:	http://dev.c6c.de
#  Licence: 		GPLv2
#  Version: 		0.3.0  -  07.02.2007
#  Desc: 		With this Script you can change your Hobbit-Configs directly with your browser
#  Note: 		Be shure what you do!! Misconfiguration can cause big problems.
#############################################
#Print HTML-Header you can't print Output before
echo "content-type: text/html"
echo ""

#############################################
# Configuration 
# Many Things will autmatically loaded
# Normaly you must only touch this section
#############################################
COLOR="blue"
THIS_TITLE="Edit Configs"

# Change to point to your hobbit server config file
HOBBIT_SERVER_CFG="../server/etc/hobbitserver.cfg"
ADMINSCRIPS_FUNCTIONS="../server/etc/adminscripts_functions.sh"

this_usePerl="false" #if you have perl (Use it when you have Problems with date (e.g. on Solaris))

#Config Files you wan't change
FILEX=(/etc/bb-hosts /etc/hobbit-alerts.cfg /etc/hobbit-alerts.cfg.111 /etc/hobbitgraph.cfg /etc/hobbitlaunch.cfg /etc/hobbitserver.cfg)

#############################################
#Init Script
#############################################
#Load Hobbit configuration
. $HOBBIT_SERVER_CFG
. $ADMINSCRIPS_FUNCTIONS
this_timestamp;this_create_time_start="$RETURN"

#Get Hobbit Version:
HOBBIT_VERSION=`$BB --version 2>&1 |$GREP "Hobbit version"|$AWK '{printf "%s",$3}'`

#init Vars
FILE=""
SELECT=""
TASK=""
query=""

#Init Environment
THIS_FILENAME=`basename $0`

#Use Requestparameters from GET or Post
if [ "$REQUEST_METHOD" = POST ]; then
	read -n $CONTENT_LENGTH query
else
    query="$QUERY_STRING"
fi

#Check Query
this_cgiascii "$query"
this_getQuery "$query" "file";FILE="$RETURN"
this_getQuery "$query" "file_enc";FILE_ENC="$RETURN"
this_quotedecode "$FILE_ENC";FILE_DEC="$RETURN"
this_getQuery "$query" "select";SELECT="$RETURN"
this_getQuery "$query" "task";TASK="$RETURN"

#############################################
#Print HTML Page
#############################################
# Load Header
. "$BBHOME/web/adminscripts_header"

#Firstly Ask for Edit or Edit 
if [ "$TASK" = "ASK" ]; then
	this_quoteencode "$FILE";FILE_ENC="$RETURN"
    echo "Are you shure you wan't edit $SELECT?"
	echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
	<input type=\"hidden\" name=\"file_enc\" value=\"$FILE_ENC\" />
	<input type=\"hidden\" name=\"select\" value=\"$SELECT\" />
	<input type=\"hidden\" name=\"task\" value=\"EDIT\" />
	<input type=\"submit\" value=\"Submit\" /></form><br />"
else
	if [ "$TASK" = "EDIT" -a "$FILE_DEC" != "" ]; then
		len=${#FILEX[*]}
		i=0
		while [ $i -lt $len ]; do
			if [ "$SELECT" = "${FILEX[$i]}" ]; then
				#make Backup if Posible
				$CAT "$BBHOME${FILEX[$i]}" > "$BBHOME${FILEX[$i]}~"
				if [ "`$CAT \"$BBHOME${FILEX[$i]}\"`" = "`$CAT \"$BBHOME${FILEX[$i]}~\"`" ]; then 
					echo "Backup created in $BBHOME${FILEX[$i]}~<br />"
				else
					echo "Backup not created<br />"
				fi 
				
				
			
				echo "$FILE_DEC" > "$BBHOME/${FILEX[$i]}"
				if [ -w "$BBHOME/${FILEX[$i]}" ]; then 
					echo "<b>$SELECT</b> successful changed"
				else 
					echo "<b>$BBHOME/${FILEX[$i]}</b> is not writeable"
				fi
			fi
			let i++
		done
	fi	
		
	#Select File to change
	echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
	<select name=\"select\">"
	len=${#FILEX[*]}
	i=0
	while [ $i -lt $len ]; do
		NAME=${FILEX[$i]}
		if [ ! -e "$BBHOME${FILEX[$i]}" ]; then
			NAME="$NAME (not exist)"
		elif [ ! -w "$BBHOME${FILEX[$i]}" ]; then
			NAME="$NAME (not writeable)"
		fi
		if [ "$SELECT" = "${FILEX[$i]}" ]; then
			TEXT=$($CAT $BBHOME/${FILEX[$i]} )
			echo "<option value=\"${FILEX[$i]}\" selected>$NAME</option>"
		else	
			echo "<option value=\"${FILEX[$i]}\">$NAME</option>"
		fi
		let i++
	done
	echo "</select>
	<input type=\"submit\" value=\"Select\"></form>"


	echo "<hr>"

	echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
	<textarea name=\"file\" cols=\"120\" rows=\"50\">$TEXT</textarea><br />
	<input type=\"hidden\" name=\"task\" value=\"ASK\" />
	<input type=\"hidden\" name=\"select\" value=\"$SELECT\" />
	<input type=\"submit\" value=\"Submit\"></form>"
	
fi



# Load Footer
this_timestamp;this_create_time_end="$RETURN"
this_create_time=$(($this_create_time_end - $this_create_time_start)) 
. "$BBHOME/web/adminscripts_footer"



exit 0;
