#!/bin/sh
#############################################
#  Autor: 		Stefan.Freisler@aspect-online.de
# Homepage:	http://dev.c6c.de
#  Licence: 		GPLv2
#  Version: 		0.3.0  -  07.02.2007
#  Desc: 		With this Script you can test Alerts, if they are right configured on 2 ways
# 			1. You can use the intern testsystem ( bbcmd hobbitd_alert --test $HOST_S $SERVICE_S )
#			2. You can change the status of an test directly by browser
#############################################
#Print HTML-Header you can't print Output before
echo "content-type: text/html"
echo ""

FAST_SERVICES="true" #Less comfort because it will not use JavaScript 
#############################################
# Configuration 
# Many Things will autmatically loaded
# Normaly you must only touch this section
#############################################
COLOR="blue"
THIS_TITLE="Test Alarm"

this_usePerl="false" #if you have perl (Use it when you have Problems with date (e.g. on Solaris))

# Change to point to your hobbit server config file
HOBBIT_SERVER_CFG="../server/etc/hobbitserver.cfg"
ADMINSCRIPS_FUNCTIONS="../server/etc/adminscripts_functions.sh"

#############################################
#Init Script
#############################################
#Load Hobbit configuration
. $HOBBIT_SERVER_CFG
. $ADMINSCRIPS_FUNCTIONS
this_timestamp;this_create_time_start="$RETURN"

#Get Hobbit Version:
HOBBIT_VERSION=`$BB --version 2>&1 |$GREP "Hobbit version"|$AWK '{printf "%s",$3}'`

#init Vars
query=""
SERVICES=""

#Init Environment
THIS_FILENAME=`basename $0`

#Use Requestparameters from GET or Post
if [ "$REQUEST_METHOD" = POST ]; then
	read -n $CONTENT_LENGTH query
else
    query="$QUERY_STRING"
fi

#Create additional Script Header

#get all Hosts Ordered and no doubles
if [ "$FAST_SERVICES" = "true" ]; then
	this_getHosts;HOSTS="$RETURN"
	this_getServices;SERVICES="$RETURN"
else
	this_getHeaderHobbitdboard;THIS_SCRIPT_HEADER="$THIS_SCRIPT_HEADER$RETURN"
fi

#Check Query
this_cgiascii "$query"
this_getQuery "$query" "hard";HARD="$RETURN"
this_getQuery "$query" "hostname";HOST_S="$RETURN"
this_getQuery "$query" "servicename";SERVICE_S="$RETURN"
this_getQuery "$query" "text";TEXT_S="$RETURN"
this_getQuery "$query" "color";COLOR_S="$RETURN"

#############################################
#Print HTML Page and do
#############################################
# Load Header
. "$BBHOME/web/adminscripts_header"

#Select Log
echo "<form action=\"./$THIS_FILENAME\" name=\"selectionform\" method=\"post\">"
if [ "$FAST_SERVICES" = "true" ]; then
	echo '<select name="hostname" size="1">'
	for HOST in $HOSTS
	do
	    echo "<option value=\"$HOST\">$HOST</option>"
	done
	echo '</select>'
	echo '<select name="servicename" size="1">'
	for SERVICE in $SERVICES
	do
	    echo "<option value=\"$SERVICE\">$SERVICE</option>"
	done
	echo '</select><br /><br />'
else
	echo '<select name="hostname" size="1" onChange="updateOptions(window.document.selectionform.hostname.options[selectedIndex].text);">'
	for HOST in $HOSTS
	do
	    echo "<option value=\"$HOST\">$HOST</option>"
	done
	echo '</select>'
	echo '<select name="servicename" size="1"><option value="">-- Select a host --</option></select><br /><br />'
fi
echo "<input type=\"checkbox\" name=\"hard\" value=\"yes\">Change Status<br />
Only Used if you would change an status <br />
<input type=\"text\" name=\"text\" value=\"Only a test\"><br />
<select name=\"color\">
	<option value=\"green\">Green</option>
	<option value=\"yellow\">Yellow</option>
	<option value=\"red\">Red</option>
	<option value=\"blue\">Blue</option>
	<option value=\"purple\">Purple</option>
	<option value=\"clear\">Clear</option>
</select><br /><br />
<input type=\"submit\" value=\"Submit\"></form>"

echo "<hr>"
#Command
if [ "$SERVICE_S" = "ALL" ]; then
	echo "The Option all is not supported yet. It's comming soon"
else
	if [ "$HARD" = "yes" ]; then
		temp_host=`echo $HOST_S|$SED "s/\./,/g"`
		res=$($BB $BBSERVERIP "status $temp_host.$SERVICE_S $COLOR_S `$DATE` $TEXT_S")
		echo "$BB $BBSERVERIP  \"status $temp_host.$SERVICE_S $COLOR_S `$DATE` $TEXT_S\""
		echo "<pre>$res</pre>"
	else
		res=$($BBHOME/bin/bbcmd hobbitd_alert --test $HOST_S $SERVICE_S)
		echo "$BBHOME/bin/bbcmd hobbitd_alert --test $HOST_S $SERVICE_S"
		echo "<pre>$res</pre>"
	fi
fi

# Load Footer
this_timestamp;this_create_time_end="$RETURN"
this_create_time=$(($this_create_time_end - $this_create_time_start)) 
. "$BBHOME/web/adminscripts_footer"

exit 0;
