#!/bin/sh
#############################################
#  Autor: 		Stefan.Freisler@aspect-online.de
# Homepage:	http://dev.c6c.de
#  Licence: 		GPLv2
#  Version: 		0.3.0  -  07.02.2007
#  Desc: 		With this Script you can view the Files in your Hobbit Server
#               		Log Path so you can handle errors faster
#############################################
#Print HTML-Header you can't print Output before
echo "content-type: text/html"
echo ""
#############################################
# Configuration 
# Many Things will autmatically loaded
# Normaly you must only touch this section
#############################################
COLOR="blue"
THIS_TITLE="View Hobbit Server Logs"

# Change to point to your hobbit server config file
HOBBIT_SERVER_CFG="../server/etc/hobbitserver.cfg"
ADMINSCRIPS_FUNCTIONS="../server/etc/adminscripts_functions.sh"
LOGS="" #if you add here Something Logspath will not set automatically

TAIL=$TAIL #Solaris user should use "/usr/xpg4/bin/tail"

this_usePerl="false" #if you have perl (Use it when you have Problems with date (e.g. on Solaris))

FILTER="applin1"
MAXLINENUMBER=1024 #How Many Lines should maximal printed

#############################################
#Init Script
#############################################
#Load Hobbit configuration
. $HOBBIT_SERVER_CFG
. $ADMINSCRIPS_FUNCTIONS
this_timestamp;this_create_time_start="$RETURN"

#Get Hobbit Version:
HOBBIT_VERSION=`$BB --version 2>&1 |$GREP "Hobbit version"|$AWK '{printf "%s",$3}'`

#initi Vars
SELECT=""
if [ "$LOGS" = "" ]; then
	LOGS=$BBSERVERLOGS
fi

#Init Environment
THIS_FILENAME=`basename $0`

#Use Requestparameters from GET or Post
if [ "$REQUEST_METHOD" = POST ]; then
	read -n $CONTENT_LENGTH query
else
    query="$QUERY_STRING"
fi

#Check Query
this_cgiascii "$query"
this_getQuery "$query" "select";SELECT="$RETURN"
this_getQuery "$query" "filter";FILTER_S="$RETURN"
this_getQuery "$query" "maxlines";MAXLINES_S="$RETURN"


#############################################
#Print HTML Page
#############################################
# Load Header
. "$BBHOME/web/adminscripts_header"

#Select Log
echo "<form action=\"./$THIS_FILENAME\" method=\"post\">
<table>
<tr><td>File:</td><td><select name=\"select\">"
for filename in $( $LS $LOGS|more ) 
do
	echo "<option value=\"$filename\">$filename</option>"
done
echo "</select></td></tr>
<tr><td>Filter:</td><td><input type=\"text\" name=\"filter\" value=\"\"></td></tr>
<tr><td>Lines:</td><td><input type=\"text\" name=\"maxlines\" value=\"$MAXLINENUMBER\"></td></tr>
<tr><td></td><td><input type=\"submit\" value=\"Submit\"></td></tr>
<table></form>"

#echo "<br /><br />$MAXLINES_S<br />"
#if [ "$MAXLINES_S" -gt "0" -o "$MAXLINES_S" -gt "$MAXLINENUMBER" ]; then
#	MAXLINES_S=$MAXLINENUMBER
#fi
#echo "$MAXLINES_S<br />"

#Print Log
echo "<hr>"
if [ "$LOGS" = "" -o "$SELECT" = "" ]; then
	echo "No Log File selected."
else
	OUTPUT=$($CAT "$LOGS/$SELECT"|$GREP "$FILTER_S"|$TAIL -n $MAXLINES_S)
	echo "Logile: $SELECT <br />"
	echo "Filter: $FILTER_S <br />"
	echo "Lines: `echo \"$OUTPUT\"|$SED '/^$/d'|$WC -l`"
	echo "<hr>"
    echo "<pre>"
	echo "$OUTPUT"
	echo "</pre>"
fi


# Load Footer
this_timestamp;this_create_time_end="$RETURN"
this_create_time=$(($this_create_time_end - $this_create_time_start)) 
. "$BBHOME/web/adminscripts_footer"

exit 0;
